package com.mc.monkeynes.hardware;

import com.mc.monkeynes.gui.*;
import com.mc.monkeynes.hardware.mapper.*;

public class NesHardware
{
  private VideoScreen          vidScreen  = null;
  
  //private NesCpu             cpu           = null;
  //private NesPpu             ppu           = null;
  private NesRom               rom           = null;
  private MemoryMapperFactory  mapperFactory = null;
  private NesMainMemory        mainMem       = null;
  private NesVideoMemory       vidMem        = null;
  private MemoryMapper         mapper        = null;     
  private HighResolutionTimer  clock         = null;
    
  public NesHardware( VideoScreen inVidScreen )
  {
    vidScreen = inVidScreen;
    
    //cpu       = new NesCpu();
    //ppu       = new NesPpu();
    mainMem       = new NesMainMemory();
    vidMem        = new NesVideoMemory();
    mapperFactory = new MemoryMapperFactory( mainMem, vidMem );
    clock         = new HighResolutionTimer( 1789773L );
  }
  
  public void insertRom( NesRom inRom )
  {
    rom    = inRom;
    mapper = mapperFactory.getMapper( rom );
  }
  
  public void powerOn()
  {
    //cpu.powerOn();
    //ppu.powerOn();
    if( mapper != null )
      mapper.powerOn();
  }
  
  public void reset()
  {
    
  }
  
  // Helper Access Functions ------------------------------------
  public VideoScreen getVideoScreen()
  {
    return vidScreen;
  }
  
  public NesRom getRom()
  {
    return rom;
  }
  
  public MemoryMapper getMemoryMapper()
  {
    return mapper;
  }
  
  public NesMainMemory getMainMemory()
  {
    return mainMem;
  }
  
  public NesVideoMemory getVidMemory()
  {
    return vidMem;
  }
  
}