package com.mc.monkeynes.hardware.mapper;

import com.mc.monkeynes.hardware.*;

public class MemoryMapperFactory
{
  private NesMainMemory  mainMem = null;
  private NesVideoMemory vidMem  = null;
  
  public MemoryMapperFactory( NesMainMemory inMainMem, NesVideoMemory inVidMem )
  {
    mainMem = inMainMem;
    vidMem  = inVidMem;
  }
  
  public MemoryMapper getMapper( NesRom inRom )
  {
    switch( inRom.getInesRomHeader().getMapperNumber() )
    {
      case 0:
        return new MemoryMapperZero( mainMem, vidMem, inRom );
      default:
        System.out.println( "Unsupported Mapper [" + inRom.getInesRomHeader().getMapperNumber() + "]" );
        return null;  
    }    
  }
}