package com.mc.monkeynes.hardware.mapper;

import com.mc.monkeynes.hardware.*;

public class MemoryMapperZero extends MemoryMapper
{
  public MemoryMapperZero( NesMainMemory inMainMem, NesVideoMemory inVidMem, NesRom inRom )
  {
    super( inMainMem, inVidMem, inRom );
  }
  
  public int getMapperNumber()
  {
    return 0;
  }
  
  public String getMapperName()
  {
    return "Mapper Zero";
  }
  
  public String getMapperDesc()
  {
    return "This mapper is used when there is no mapper.";
  }
  
  public void powerOn()
  {
    InesRomHeader iNesHead = rom.getInesRomHeader();
    
    // If the PRG-ROM size is 32k, just load it into $8000
    // If the PRG-ROM size is 16k, double load it to $8000 and $C000
    if( iNesHead.getPrgRomSize() == InesRomHeader.PRG_PAGE_SIZE )
    {
      System.out.println( rom.getPrgRomPage(0).length + " bytes of PRG-ROM loaded at Main:$8000" );
      mainMem.write( 0x00008000, rom.getPrgRomPage(0) );
      System.out.println( rom.getPrgRomPage(0).length + " bytes of PRG-ROM loaded at Main:$C000" );
      mainMem.write( 0x0000C000, rom.getPrgRomPage(0) );
    }
    else if( iNesHead.getPrgRomSize() == (InesRomHeader.PRG_PAGE_SIZE * 2) )
    {
      System.out.println( (rom.getPrgRomPage(0).length * 2) + " bytes of PRG-ROM loaded at Main:$8000" );
      mainMem.write( 0x00008000, rom.getPrgRomPage(0) );
      mainMem.write( 0x0000C000, rom.getPrgRomPage(1) );
    }
    
    // Load the CHR-ROM if there is any
    if( iNesHead.getChrRomSize() == InesRomHeader.CHR_PAGE_SIZE )
    {
      System.out.println( rom.getChrRomPage(0).length + " bytes of CHR-ROM loaded at Vid:$0000" );
      vidMem.write( 0x00000000, rom.getChrRomPage(0) );
    }
  }
}